import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Buttons extends JFrame {
	
	public Buttons() {
		super("Buttons");

		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new BorderLayout());
		
		JTextField textField = new JTextField();
		add(textField,BorderLayout.NORTH);
		
		JPanel digitPanel = new JPanel();
		digitPanel.setLayout(new GridLayout(4,3,3,3));
		
		JButton[] digitButtons = new JButton[10];
		for (int i=0; i<=9; i++) {
			digitButtons[i] = makeButton(i,textField);
		}
		digitPanel.add(digitButtons[7]);
		digitPanel.add(digitButtons[8]);
		digitPanel.add(digitButtons[9]);
		digitPanel.add(digitButtons[4]);
		digitPanel.add(digitButtons[5]);
		digitPanel.add(digitButtons[6]);
		digitPanel.add(digitButtons[1]);
		digitPanel.add(digitButtons[2]);
		digitPanel.add(digitButtons[3]);
		digitPanel.add(digitButtons[0]);
		digitPanel.add(makeClearButton(textField));
		digitPanel.add(makeDelButton(textField));
		
		add(digitPanel,BorderLayout.SOUTH);
		
		pack();
		setVisible(true);
	}
	
	private JButton makeButton(final int index, final JTextField textField) {
		JButton button = new JButton(""+index);
		button.setPreferredSize(new Dimension(100,50));
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			    String str = textField.getText();
				textField.setText(str + index);
			}
		});
		
	    return button;
	}

	private JButton makeClearButton(final JTextField textField) {
		JButton clearButton = new JButton("Clear");
		clearButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			    textField.setText("");
			}
		});
		
		return clearButton;
	}
	
	private JButton makeDelButton(final JTextField textField) {
		JButton delButton = new JButton("Del");
		delButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			    String str = textField.getText();
			    int n = str.length();
			    if (n > 0)
			    	textField.setText(str.substring(0,n-1));
			}
		});
		
		return delButton;
	}

	public static void main(String[] args) {
		new Buttons();
	}
	
}