import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

public class Mouse extends JFrame {
	
	final static int numRows = 8;
	final static int numCols = 8;
	
	final static Font f1 = new Font("Dialog", Font.PLAIN, 14);
	final static Font f2 = new Font("Dialog", Font.PLAIN, 24);
	final static Font f3 = new Font("Dialog", Font.BOLD, 24);
	
	public Mouse() {
		super("Mouse");

		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new BorderLayout());
		
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(numRows,numCols));
		
		int numLabels = numRows * numCols;
		JLabel[] labels = new JLabel[numLabels];
		boolean[] set = new boolean[numLabels];
		
		int index = 0;
		for (int i=0; i<numRows; i++)
			for (int j=0; j<numCols; j++) {
				labels[index] = makeLabel(index,labels,set);
				panel.add(labels[index]);
				index++;
			}
		
		add(panel);
		
		pack();
		setVisible(true);
	}
	
	
	private JLabel makeLabel(final int index, final JLabel[] labels, final boolean[] set) {
		JLabel label = new JLabel(""+index,JLabel.CENTER);
		label.setFont(f1);
		label.setPreferredSize(new Dimension(60,30));

		label.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent e) {
				if (set[index]) {
					labels[index].setText(""+index);
					set[index] = false;
				}
				else {
					labels[index].setText("");
					set[index] = true;
				}
			}
			
			public void mouseEntered(MouseEvent e) {
				labels[index].setFont(f2);
			}
			
			public void mouseExited(MouseEvent e) {
				labels[index].setFont(f1);				
			}
			
			public void mousePressed(MouseEvent e) {
				labels[index].setFont(f3);				
			}
			
			public void mouseReleased(MouseEvent e) {
											
			}
		});
		
	    return label;
	}
	
	public static void main(String[] args) {
		new Mouse();
	}
	
}
